.tf:push:
  
  before_script:
    -  |-
      if [ "$CI_DEFAULT_BRANCH" == "$CI_COMMIT_BRANCH" ]
      then
        /usr/bin/env
        export GOOGLE_APPLICATION_CREDENTIALS=$GCP_APPLICATION_CREDENTIALS
      
      elif [ "$CI_COMMIT_BRANCH" == "$BRANCH_DEV" ]
      then
        /usr/bin/env
        export GOOGLE_APPLICATION_CREDENTIALS=$GCP_APPLICATION_CREDENTIALS 
      
      else
        echo "BRANCH NAO DEFINIDA"
      fi

    ###- '/usr/bin/env'
    #- 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
    #- 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - cd infrastructure/gcp/subnet/
    - terraform --version
    - |-
      terraform init -reconfigure 

  image:
    name: hashicorp/terraform:light
    entrypoint: ['']

validar_tf:
  stage: validate
  extends: .tf:push
  environment:
    name: production
  script:
  - ls
  - terraform validate
  cache:
    key: terraform
    paths:
    - .terraform
  only:
    changes:  
      - infrastructure/**/subnet/*

plan_tf:
  stage: plan
  extends: .tf:push
  environment:
    name: production
  script:
    - 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - terraform plan
  dependencies:
    - validar_tf
  only:
    changes:  
      - infrastructure/**/subnet/*

apply_tf:
  stage: apply
  extends: .tf:push
  environment:
    name: production
  script:
    - 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - terraform apply --auto-approve
  dependencies:
    - plan_tf
  when: manual
  only:
    changes:  
      - infrastructure/**/subnet/*
  
destroy_tf:
  stage: destroy
  extends: .tf:push
  environment:
    name: production
  script:
    - 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - terraform destroy --auto-approve
  dependencies:
    - plan_tf_redis
  when: manual
  only:
    changes:  
      - infrastructure/**/subnet/*